#ifdef __cplusplus
extern "C" { 
#endif

#ifndef __HROOT_CORE__
#define __HROOT_CORE__

// Opaque type definition for Deletable 
typedef struct Deletable_tag Deletable_t; 
typedef Deletable_t * Deletable_p; 
typedef Deletable_t const* const_Deletable_p; 

// Opaque type definition for TApplication 
typedef struct TApplication_tag TApplication_t; 
typedef TApplication_t * TApplication_p; 
typedef TApplication_t const* const_TApplication_p; 

// Opaque type definition for TArray 
typedef struct TArray_tag TArray_t; 
typedef TArray_t * TArray_p; 
typedef TArray_t const* const_TArray_p; 

// Opaque type definition for TArrayC 
typedef struct TArrayC_tag TArrayC_t; 
typedef TArrayC_t * TArrayC_p; 
typedef TArrayC_t const* const_TArrayC_p; 

// Opaque type definition for TArrayD 
typedef struct TArrayD_tag TArrayD_t; 
typedef TArrayD_t * TArrayD_p; 
typedef TArrayD_t const* const_TArrayD_p; 

// Opaque type definition for TArrayF 
typedef struct TArrayF_tag TArrayF_t; 
typedef TArrayF_t * TArrayF_p; 
typedef TArrayF_t const* const_TArrayF_p; 

// Opaque type definition for TArrayI 
typedef struct TArrayI_tag TArrayI_t; 
typedef TArrayI_t * TArrayI_p; 
typedef TArrayI_t const* const_TArrayI_p; 

// Opaque type definition for TArrayL 
typedef struct TArrayL_tag TArrayL_t; 
typedef TArrayL_t * TArrayL_p; 
typedef TArrayL_t const* const_TArrayL_p; 

// Opaque type definition for TArrayL64 
typedef struct TArrayL64_tag TArrayL64_t; 
typedef TArrayL64_t * TArrayL64_p; 
typedef TArrayL64_t const* const_TArrayL64_p; 

// Opaque type definition for TArrayS 
typedef struct TArrayS_tag TArrayS_t; 
typedef TArrayS_t * TArrayS_p; 
typedef TArrayS_t const* const_TArrayS_p; 

// Opaque type definition for TAtt3D 
typedef struct TAtt3D_tag TAtt3D_t; 
typedef TAtt3D_t * TAtt3D_p; 
typedef TAtt3D_t const* const_TAtt3D_p; 

// Opaque type definition for TAttAxis 
typedef struct TAttAxis_tag TAttAxis_t; 
typedef TAttAxis_t * TAttAxis_p; 
typedef TAttAxis_t const* const_TAttAxis_p; 

// Opaque type definition for TAttBBox 
typedef struct TAttBBox_tag TAttBBox_t; 
typedef TAttBBox_t * TAttBBox_p; 
typedef TAttBBox_t const* const_TAttBBox_p; 

// Opaque type definition for TAttCanvas 
typedef struct TAttCanvas_tag TAttCanvas_t; 
typedef TAttCanvas_t * TAttCanvas_p; 
typedef TAttCanvas_t const* const_TAttCanvas_p; 

// Opaque type definition for TAttFill 
typedef struct TAttFill_tag TAttFill_t; 
typedef TAttFill_t * TAttFill_p; 
typedef TAttFill_t const* const_TAttFill_p; 

// Opaque type definition for TAttLine 
typedef struct TAttLine_tag TAttLine_t; 
typedef TAttLine_t * TAttLine_p; 
typedef TAttLine_t const* const_TAttLine_p; 

// Opaque type definition for TAttMarker 
typedef struct TAttMarker_tag TAttMarker_t; 
typedef TAttMarker_t * TAttMarker_p; 
typedef TAttMarker_t const* const_TAttMarker_p; 

// Opaque type definition for TAttPad 
typedef struct TAttPad_tag TAttPad_t; 
typedef TAttPad_t * TAttPad_p; 
typedef TAttPad_t const* const_TAttPad_p; 

// Opaque type definition for TAttText 
typedef struct TAttText_tag TAttText_t; 
typedef TAttText_t * TAttText_p; 
typedef TAttText_t const* const_TAttText_p; 

// Opaque type definition for TClass 
typedef struct TClass_tag TClass_t; 
typedef TClass_t * TClass_p; 
typedef TClass_t const* const_TClass_p; 

// Opaque type definition for TCollection 
typedef struct TCollection_tag TCollection_t; 
typedef TCollection_t * TCollection_p; 
typedef TCollection_t const* const_TCollection_p; 

// Opaque type definition for TDictionary 
typedef struct TDictionary_tag TDictionary_t; 
typedef TDictionary_t * TDictionary_p; 
typedef TDictionary_t const* const_TDictionary_p; 

// Opaque type definition for TDirectory 
typedef struct TDirectory_tag TDirectory_t; 
typedef TDirectory_t * TDirectory_p; 
typedef TDirectory_t const* const_TDirectory_p; 

// Opaque type definition for TGlobal 
typedef struct TGlobal_tag TGlobal_t; 
typedef TGlobal_t * TGlobal_p; 
typedef TGlobal_t const* const_TGlobal_p; 

// Opaque type definition for TKey 
typedef struct TKey_tag TKey_t; 
typedef TKey_t * TKey_p; 
typedef TKey_t const* const_TKey_p; 

// Opaque type definition for TNamed 
typedef struct TNamed_tag TNamed_t; 
typedef TNamed_t * TNamed_p; 
typedef TNamed_t const* const_TNamed_p; 

// Opaque type definition for TObjArray 
typedef struct TObjArray_tag TObjArray_t; 
typedef TObjArray_t * TObjArray_p; 
typedef TObjArray_t const* const_TObjArray_p; 

// Opaque type definition for TObject 
typedef struct TObject_tag TObject_t; 
typedef TObject_t * TObject_p; 
typedef TObject_t const* const_TObject_p; 

// Opaque type definition for TQObject 
typedef struct TQObject_tag TQObject_t; 
typedef TQObject_t * TQObject_p; 
typedef TQObject_t const* const_TQObject_p; 

// Opaque type definition for TROOT 
typedef struct TROOT_tag TROOT_t; 
typedef TROOT_t * TROOT_p; 
typedef TROOT_t const* const_TROOT_p; 

// Opaque type definition for TSeqCollection 
typedef struct TSeqCollection_tag TSeqCollection_t; 
typedef TSeqCollection_t * TSeqCollection_p; 
typedef TSeqCollection_t const* const_TSeqCollection_p; 

// Opaque type definition for TSystem 
typedef struct TSystem_tag TSystem_t; 
typedef TSystem_t * TSystem_p; 
typedef TSystem_t const* const_TSystem_p; 

// Opaque type definition for TVirtualPad 
typedef struct TVirtualPad_tag TVirtualPad_t; 
typedef TVirtualPad_t * TVirtualPad_p; 
typedef TVirtualPad_t const* const_TVirtualPad_p; 

#endif // __HROOT_CORE__

#ifdef __cplusplus
}
#endif
