#ifdef __cplusplus
extern "C" { 
#endif 

#ifndef __HROOT_CORE__TAttFill__
#define __HROOT_CORE__TAttFill__

#include "HROOT-coreType.h"

#include "HROOTCoreDeletable.h"

#undef TATTFILL_DECL_VIRT
#define TATTFILL_DECL_VIRT(Type) \
void Type ## _SetFillColor ( Type ## _p p, int color ); \
void Type ## _SetFillStyle ( Type ## _p p, int style )

#undef TATTFILL_DECL_NONVIRT
#define TATTFILL_DECL_NONVIRT(Type) \
Type ## _p Type ## _newTAttFill ( int fcolor, int fstyle )

#undef TATTFILL_DEF_VIRT
#define TATTFILL_DEF_VIRT(Type)\
void Type ## _SetFillColor ( Type ## _p p, int color )\
{\
TYPECASTMETHOD(Type,SetFillColor,TAttFill)(p)->SetFillColor(color);\
}\
void Type ## _SetFillStyle ( Type ## _p p, int style )\
{\
TYPECASTMETHOD(Type,SetFillStyle,TAttFill)(p)->SetFillStyle(style);\
}

#undef TATTFILL_DEF_NONVIRT
#define TATTFILL_DEF_NONVIRT(Type)\
Type ## _p Type ## _newTAttFill ( int fcolor, int fstyle )\
{\
Type * newp = new Type (fcolor, fstyle); \
return to_nonconst<Type ## _t, Type >(newp);\
}

DELETABLE_DECL_VIRT(TAttFill);


TATTFILL_DECL_VIRT(TAttFill);


TATTFILL_DECL_NONVIRT(TAttFill);


#endif // __HROOT_CORE__TAttFill__

#ifdef __cplusplus
}
#endif
