#ifdef __cplusplus
extern "C" { 
#endif 

#ifndef __HROOT_CORE__TROOT__
#define __HROOT_CORE__TROOT__

#include "HROOT-coreType.h"

#include "HROOTCoreTDirectory.h"
#include "HROOTCoreTNamed.h"
#include "HROOTCoreTObject.h"
#include "HROOTCoreDeletable.h"

#undef TROOT_DECL_VIRT
#define TROOT_DECL_VIRT(Type) \


#undef TROOT_DECL_NONVIRT
#define TROOT_DECL_NONVIRT(Type) \
TGlobal_p Type ## _tROOTGetGlobal ( Type ## _p p, const char* name, int load ); \
int Type ## _tROOTInitialized (  )

#undef TROOT_DEF_VIRT
#define TROOT_DEF_VIRT(Type)\


#undef TROOT_DEF_NONVIRT
#define TROOT_DEF_NONVIRT(Type)\
TGlobal_p Type ## _tROOTGetGlobal ( Type ## _p p, const char* name, int load )\
{\
return to_nonconst<TGlobal_t,TGlobal>((TGlobal*)TYPECASTMETHOD(Type,tROOTGetGlobal,TROOT)(p)->GetGlobal(name, load));\
}\
int Type ## _tROOTInitialized (  )\
{\
return TROOT::Initialized();\
}

TDIRECTORY_DECL_VIRT(TROOT);
TNAMED_DECL_VIRT(TROOT);
TOBJECT_DECL_VIRT(TROOT);
DELETABLE_DECL_VIRT(TROOT);


TROOT_DECL_VIRT(TROOT);


TROOT_DECL_NONVIRT(TROOT);


#endif // __HROOT_CORE__TROOT__

#ifdef __cplusplus
}
#endif
