#ifdef __cplusplus
extern "C" { 
#endif 

#ifndef __HROOT_CORE__TSystem__
#define __HROOT_CORE__TSystem__

#include "HROOT-coreType.h"

#include "HROOTCoreTNamed.h"
#include "HROOTCoreTObject.h"
#include "HROOTCoreDeletable.h"

#undef TSYSTEM_DECL_VIRT
#define TSYSTEM_DECL_VIRT(Type) \
int Type ## _ProcessEvents ( Type ## _p p )

#undef TSYSTEM_DECL_NONVIRT
#define TSYSTEM_DECL_NONVIRT(Type) \


#undef TSYSTEM_DEF_VIRT
#define TSYSTEM_DEF_VIRT(Type)\
int Type ## _ProcessEvents ( Type ## _p p )\
{\
return TYPECASTMETHOD(Type,ProcessEvents,TSystem)(p)->ProcessEvents();\
}

#undef TSYSTEM_DEF_NONVIRT
#define TSYSTEM_DEF_NONVIRT(Type)\


TNAMED_DECL_VIRT(TSystem);
TOBJECT_DECL_VIRT(TSystem);
DELETABLE_DECL_VIRT(TSystem);


TSYSTEM_DECL_VIRT(TSystem);


TSYSTEM_DECL_NONVIRT(TSystem);


#endif // __HROOT_CORE__TSystem__

#ifdef __cplusplus
}
#endif
