{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Core.TApplication.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Core.TApplication.RawType
import HROOT.Core.TObject.RawType
import HROOT.Core.TClass.RawType

#include "HROOTCoreTApplication.h"

foreign import ccall "HROOTCoreTApplication.h TApplication_Draw" c_tapplication_draw 
  :: (Ptr RawTApplication) -> CString -> IO ()

foreign import ccall "HROOTCoreTApplication.h TApplication_FindObject" c_tapplication_findobject 
  :: (Ptr RawTApplication) -> CString -> IO (Ptr RawTObject)

foreign import ccall "HROOTCoreTApplication.h TApplication_GetName" c_tapplication_getname 
  :: (Ptr RawTApplication) -> IO CString

foreign import ccall "HROOTCoreTApplication.h TApplication_IsA" c_tapplication_isa 
  :: (Ptr RawTApplication) -> IO (Ptr RawTClass)

foreign import ccall "HROOTCoreTApplication.h TApplication_Paint" c_tapplication_paint 
  :: (Ptr RawTApplication) -> CString -> IO ()

foreign import ccall "HROOTCoreTApplication.h TApplication_printObj" c_tapplication_printobj 
  :: (Ptr RawTApplication) -> CString -> IO ()

foreign import ccall "HROOTCoreTApplication.h TApplication_SaveAs" c_tapplication_saveas 
  :: (Ptr RawTApplication) -> CString -> CString -> IO ()

foreign import ccall "HROOTCoreTApplication.h TApplication_Write" c_tapplication_write 
  :: (Ptr RawTApplication) -> CString -> CInt -> CInt -> IO CInt

foreign import ccall "HROOTCoreTApplication.h TApplication_delete" c_tapplication_delete 
  :: (Ptr RawTApplication) -> IO ()

foreign import ccall "HROOTCoreTApplication.h TApplication_newTApplication" c_tapplication_newtapplication 
  :: CString -> (Ptr CInt) -> (Ptr (CString)) -> IO (Ptr RawTApplication)

foreign import ccall "HROOTCoreTApplication.h TApplication_Run" c_tapplication_run 
  :: (Ptr RawTApplication) -> CInt -> IO ()

