{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Core.TDirectory.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Core.TDirectory.RawType
import HROOT.Core.TObject.RawType
import HROOT.Core.TClass.RawType
import HROOT.Core.TKey.RawType

#include "HROOTCoreTDirectory.h"

foreign import ccall "HROOTCoreTDirectory.h TDirectory_SetName" c_tdirectory_setname 
  :: (Ptr RawTDirectory) -> CString -> IO ()

foreign import ccall "HROOTCoreTDirectory.h TDirectory_SetNameTitle" c_tdirectory_setnametitle 
  :: (Ptr RawTDirectory) -> CString -> CString -> IO ()

foreign import ccall "HROOTCoreTDirectory.h TDirectory_SetTitle" c_tdirectory_settitle 
  :: (Ptr RawTDirectory) -> CString -> IO ()

foreign import ccall "HROOTCoreTDirectory.h TDirectory_Draw" c_tdirectory_draw 
  :: (Ptr RawTDirectory) -> CString -> IO ()

foreign import ccall "HROOTCoreTDirectory.h TDirectory_FindObject" c_tdirectory_findobject 
  :: (Ptr RawTDirectory) -> CString -> IO (Ptr RawTObject)

foreign import ccall "HROOTCoreTDirectory.h TDirectory_GetName" c_tdirectory_getname 
  :: (Ptr RawTDirectory) -> IO CString

foreign import ccall "HROOTCoreTDirectory.h TDirectory_IsA" c_tdirectory_isa 
  :: (Ptr RawTDirectory) -> IO (Ptr RawTClass)

foreign import ccall "HROOTCoreTDirectory.h TDirectory_Paint" c_tdirectory_paint 
  :: (Ptr RawTDirectory) -> CString -> IO ()

foreign import ccall "HROOTCoreTDirectory.h TDirectory_printObj" c_tdirectory_printobj 
  :: (Ptr RawTDirectory) -> CString -> IO ()

foreign import ccall "HROOTCoreTDirectory.h TDirectory_SaveAs" c_tdirectory_saveas 
  :: (Ptr RawTDirectory) -> CString -> CString -> IO ()

foreign import ccall "HROOTCoreTDirectory.h TDirectory_Write" c_tdirectory_write 
  :: (Ptr RawTDirectory) -> CString -> CInt -> CInt -> IO CInt

foreign import ccall "HROOTCoreTDirectory.h TDirectory_delete" c_tdirectory_delete 
  :: (Ptr RawTDirectory) -> IO ()

foreign import ccall "HROOTCoreTDirectory.h TDirectory_tDirectoryAddDirectory" c_tdirectory_tdirectoryadddirectory 
  :: CInt -> IO ()

foreign import ccall "HROOTCoreTDirectory.h TDirectory_tDirectoryAddDirectoryStatus" c_tdirectory_tdirectoryadddirectorystatus 
  :: IO CInt

foreign import ccall "HROOTCoreTDirectory.h TDirectory_Append" c_tdirectory_append 
  :: (Ptr RawTDirectory) -> (Ptr RawTObject) -> CInt -> IO ()

foreign import ccall "HROOTCoreTDirectory.h TDirectory_addD" c_tdirectory_addd 
  :: (Ptr RawTDirectory) -> (Ptr RawTObject) -> CInt -> IO ()

foreign import ccall "HROOTCoreTDirectory.h TDirectory_AppendKey" c_tdirectory_appendkey 
  :: (Ptr RawTDirectory) -> (Ptr RawTKey) -> IO CInt

foreign import ccall "HROOTCoreTDirectory.h TDirectory_Close" c_tdirectory_close 
  :: (Ptr RawTDirectory) -> CString -> IO ()

foreign import ccall "HROOTCoreTDirectory.h TDirectory_Get" c_tdirectory_get 
  :: (Ptr RawTDirectory) -> CString -> IO (Ptr RawTObject)

foreign import ccall "HROOTCoreTDirectory.h TDirectory_cd_TDirectory" c_tdirectory_cd_tdirectory 
  :: (Ptr RawTDirectory) -> CString -> IO CInt

