{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Core.TGlobal.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Core.TGlobal.RawType
import HROOT.Core.TObject.RawType
import HROOT.Core.TClass.RawType

#include "HROOTCoreTGlobal.h"

foreign import ccall "HROOTCoreTGlobal.h TGlobal_SetName" c_tglobal_setname 
  :: (Ptr RawTGlobal) -> CString -> IO ()

foreign import ccall "HROOTCoreTGlobal.h TGlobal_SetNameTitle" c_tglobal_setnametitle 
  :: (Ptr RawTGlobal) -> CString -> CString -> IO ()

foreign import ccall "HROOTCoreTGlobal.h TGlobal_SetTitle" c_tglobal_settitle 
  :: (Ptr RawTGlobal) -> CString -> IO ()

foreign import ccall "HROOTCoreTGlobal.h TGlobal_Draw" c_tglobal_draw 
  :: (Ptr RawTGlobal) -> CString -> IO ()

foreign import ccall "HROOTCoreTGlobal.h TGlobal_FindObject" c_tglobal_findobject 
  :: (Ptr RawTGlobal) -> CString -> IO (Ptr RawTObject)

foreign import ccall "HROOTCoreTGlobal.h TGlobal_GetName" c_tglobal_getname 
  :: (Ptr RawTGlobal) -> IO CString

foreign import ccall "HROOTCoreTGlobal.h TGlobal_IsA" c_tglobal_isa 
  :: (Ptr RawTGlobal) -> IO (Ptr RawTClass)

foreign import ccall "HROOTCoreTGlobal.h TGlobal_Paint" c_tglobal_paint 
  :: (Ptr RawTGlobal) -> CString -> IO ()

foreign import ccall "HROOTCoreTGlobal.h TGlobal_printObj" c_tglobal_printobj 
  :: (Ptr RawTGlobal) -> CString -> IO ()

foreign import ccall "HROOTCoreTGlobal.h TGlobal_SaveAs" c_tglobal_saveas 
  :: (Ptr RawTGlobal) -> CString -> CString -> IO ()

foreign import ccall "HROOTCoreTGlobal.h TGlobal_Write" c_tglobal_write 
  :: (Ptr RawTGlobal) -> CString -> CInt -> CInt -> IO CInt

foreign import ccall "HROOTCoreTGlobal.h TGlobal_delete" c_tglobal_delete 
  :: (Ptr RawTGlobal) -> IO ()

