#ifdef __cplusplus
extern "C" { 
#endif 

#ifndef __HROOT_CORE__Deletable__
#define __HROOT_CORE__Deletable__

#include "HROOT-coreType.h"



#undef DELETABLE_DECL_VIRT
#define DELETABLE_DECL_VIRT(Type) \
void Type ## _delete ( Type ## _p p )

#undef DELETABLE_DECL_NONVIRT
#define DELETABLE_DECL_NONVIRT(Type) \


#undef DELETABLE_DEF_VIRT
#define DELETABLE_DEF_VIRT(Type)\
void Type ## _delete ( Type ## _p p )\
{\
delete (to_nonconst<Type,Type ## _t>(p)) ; \
}

#undef DELETABLE_DEF_NONVIRT
#define DELETABLE_DEF_NONVIRT(Type)\




#endif // __HROOT_CORE__Deletable__

#ifdef __cplusplus
}
#endif
