#ifdef __cplusplus
extern "C" { 
#endif 

#ifndef __HROOT_CORE__TAttAxis__
#define __HROOT_CORE__TAttAxis__

#include "HROOT-coreType.h"

#include "HROOTCoreDeletable.h"

#undef TATTAXIS_DECL_VIRT
#define TATTAXIS_DECL_VIRT(Type) \
int Type ## _GetNdivisions ( Type ## _p p ); \
int Type ## _GetAxisColor ( Type ## _p p ); \
int Type ## _GetLabelColor ( Type ## _p p ); \
int Type ## _GetLabelFont ( Type ## _p p ); \
double Type ## _GetLabelOffset ( Type ## _p p ); \
double Type ## _GetLabelSize ( Type ## _p p ); \
double Type ## _GetTitleOffset ( Type ## _p p ); \
double Type ## _GetTitleSize ( Type ## _p p ); \
double Type ## _GetTickLength ( Type ## _p p ); \
int Type ## _GetTitleFont ( Type ## _p p ); \
void Type ## _SetNdivisions ( Type ## _p p, int n, int optim ); \
void Type ## _SetAxisColor ( Type ## _p p, int color ); \
void Type ## _SetLabelColor ( Type ## _p p, int color ); \
void Type ## _SetLabelFont ( Type ## _p p, int font ); \
void Type ## _SetLabelOffset ( Type ## _p p, double offset ); \
void Type ## _SetLabelSize ( Type ## _p p, double size ); \
void Type ## _SetTickLength ( Type ## _p p, double length ); \
void Type ## _SetTitleOffset ( Type ## _p p, double offset ); \
void Type ## _SetTitleSize ( Type ## _p p, double size ); \
void Type ## _SetTitleColor ( Type ## _p p, int color ); \
void Type ## _SetTitleFont ( Type ## _p p, int font )

#undef TATTAXIS_DECL_NONVIRT
#define TATTAXIS_DECL_NONVIRT(Type) \
Type ## _p Type ## _newTAttAxis (  )

#undef TATTAXIS_DEF_VIRT
#define TATTAXIS_DEF_VIRT(Type)\
int Type ## _GetNdivisions ( Type ## _p p )\
{\
return TYPECASTMETHOD(Type,GetNdivisions,TAttAxis)(p)->GetNdivisions();\
}\
int Type ## _GetAxisColor ( Type ## _p p )\
{\
return TYPECASTMETHOD(Type,GetAxisColor,TAttAxis)(p)->GetAxisColor();\
}\
int Type ## _GetLabelColor ( Type ## _p p )\
{\
return TYPECASTMETHOD(Type,GetLabelColor,TAttAxis)(p)->GetLabelColor();\
}\
int Type ## _GetLabelFont ( Type ## _p p )\
{\
return TYPECASTMETHOD(Type,GetLabelFont,TAttAxis)(p)->GetLabelFont();\
}\
double Type ## _GetLabelOffset ( Type ## _p p )\
{\
return TYPECASTMETHOD(Type,GetLabelOffset,TAttAxis)(p)->GetLabelOffset();\
}\
double Type ## _GetLabelSize ( Type ## _p p )\
{\
return TYPECASTMETHOD(Type,GetLabelSize,TAttAxis)(p)->GetLabelSize();\
}\
double Type ## _GetTitleOffset ( Type ## _p p )\
{\
return TYPECASTMETHOD(Type,GetTitleOffset,TAttAxis)(p)->GetTitleOffset();\
}\
double Type ## _GetTitleSize ( Type ## _p p )\
{\
return TYPECASTMETHOD(Type,GetTitleSize,TAttAxis)(p)->GetTitleSize();\
}\
double Type ## _GetTickLength ( Type ## _p p )\
{\
return TYPECASTMETHOD(Type,GetTickLength,TAttAxis)(p)->GetTickLength();\
}\
int Type ## _GetTitleFont ( Type ## _p p )\
{\
return TYPECASTMETHOD(Type,GetTitleFont,TAttAxis)(p)->GetTitleFont();\
}\
void Type ## _SetNdivisions ( Type ## _p p, int n, int optim )\
{\
TYPECASTMETHOD(Type,SetNdivisions,TAttAxis)(p)->SetNdivisions(n, optim);\
}\
void Type ## _SetAxisColor ( Type ## _p p, int color )\
{\
TYPECASTMETHOD(Type,SetAxisColor,TAttAxis)(p)->SetAxisColor(color);\
}\
void Type ## _SetLabelColor ( Type ## _p p, int color )\
{\
TYPECASTMETHOD(Type,SetLabelColor,TAttAxis)(p)->SetLabelColor(color);\
}\
void Type ## _SetLabelFont ( Type ## _p p, int font )\
{\
TYPECASTMETHOD(Type,SetLabelFont,TAttAxis)(p)->SetLabelFont(font);\
}\
void Type ## _SetLabelOffset ( Type ## _p p, double offset )\
{\
TYPECASTMETHOD(Type,SetLabelOffset,TAttAxis)(p)->SetLabelOffset(offset);\
}\
void Type ## _SetLabelSize ( Type ## _p p, double size )\
{\
TYPECASTMETHOD(Type,SetLabelSize,TAttAxis)(p)->SetLabelSize(size);\
}\
void Type ## _SetTickLength ( Type ## _p p, double length )\
{\
TYPECASTMETHOD(Type,SetTickLength,TAttAxis)(p)->SetTickLength(length);\
}\
void Type ## _SetTitleOffset ( Type ## _p p, double offset )\
{\
TYPECASTMETHOD(Type,SetTitleOffset,TAttAxis)(p)->SetTitleOffset(offset);\
}\
void Type ## _SetTitleSize ( Type ## _p p, double size )\
{\
TYPECASTMETHOD(Type,SetTitleSize,TAttAxis)(p)->SetTitleSize(size);\
}\
void Type ## _SetTitleColor ( Type ## _p p, int color )\
{\
TYPECASTMETHOD(Type,SetTitleColor,TAttAxis)(p)->SetTitleColor(color);\
}\
void Type ## _SetTitleFont ( Type ## _p p, int font )\
{\
TYPECASTMETHOD(Type,SetTitleFont,TAttAxis)(p)->SetTitleFont(font);\
}

#undef TATTAXIS_DEF_NONVIRT
#define TATTAXIS_DEF_NONVIRT(Type)\
Type ## _p Type ## _newTAttAxis (  )\
{\
Type * newp = new Type (); \
return to_nonconst<Type ## _t, Type >(newp);\
}

DELETABLE_DECL_VIRT(TAttAxis);


TATTAXIS_DECL_VIRT(TAttAxis);


TATTAXIS_DECL_NONVIRT(TAttAxis);


#endif // __HROOT_CORE__TAttAxis__

#ifdef __cplusplus
}
#endif
