#ifdef __cplusplus
extern "C" { 
#endif 

#ifndef __HROOT_CORE__TVirtualPad__
#define __HROOT_CORE__TVirtualPad__

#include "HROOT-coreType.h"

#include "HROOTCoreTObject.h"
#include "HROOTCoreDeletable.h"

#undef TVIRTUALPAD_DECL_VIRT
#define TVIRTUALPAD_DECL_VIRT(Type) \
Type ## _p Type ## _cd ( Type ## _p p, int subpadnumber ); \
void Type ## _divide_tvirtualpad ( Type ## _p p, int nx, int ny, double xmargin, double ymargin, int color ); \
void Type ## _SetLogx ( Type ## _p p, int value ); \
void Type ## _SetLogy ( Type ## _p p, int value ); \
void Type ## _SetLogz ( Type ## _p p, int value )

#undef TVIRTUALPAD_DECL_NONVIRT
#define TVIRTUALPAD_DECL_NONVIRT(Type) \


#undef TVIRTUALPAD_DEF_VIRT
#define TVIRTUALPAD_DEF_VIRT(Type)\
Type ## _p Type ## _cd ( Type ## _p p, int subpadnumber )\
{\
return to_nonconst<Type ## _t, Type>((Type *)TYPECASTMETHOD(Type,cd,TVirtualPad)(p)->cd(subpadnumber)) ;\
}\
void Type ## _divide_tvirtualpad ( Type ## _p p, int nx, int ny, double xmargin, double ymargin, int color )\
{\
TYPECASTMETHOD(Type,divide_tvirtualpad,TVirtualPad)(p)->Divide(nx, ny, xmargin, ymargin, color);\
}\
void Type ## _SetLogx ( Type ## _p p, int value )\
{\
TYPECASTMETHOD(Type,SetLogx,TVirtualPad)(p)->SetLogx(value);\
}\
void Type ## _SetLogy ( Type ## _p p, int value )\
{\
TYPECASTMETHOD(Type,SetLogy,TVirtualPad)(p)->SetLogy(value);\
}\
void Type ## _SetLogz ( Type ## _p p, int value )\
{\
TYPECASTMETHOD(Type,SetLogz,TVirtualPad)(p)->SetLogz(value);\
}

#undef TVIRTUALPAD_DEF_NONVIRT
#define TVIRTUALPAD_DEF_NONVIRT(Type)\


TOBJECT_DECL_VIRT(TVirtualPad);
DELETABLE_DECL_VIRT(TVirtualPad);


TVIRTUALPAD_DECL_VIRT(TVirtualPad);


TVIRTUALPAD_DECL_NONVIRT(TVirtualPad);


#endif // __HROOT_CORE__TVirtualPad__

#ifdef __cplusplus
}
#endif
