{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Core.TNamed.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Core.TNamed.RawType
import HROOT.Core.TObject.RawType
import HROOT.Core.TClass.RawType

#include "HROOTCoreTNamed.h"

foreign import ccall "HROOTCoreTNamed.h TNamed_Draw" c_tnamed_draw 
  :: (Ptr RawTNamed) -> CString -> IO ()

foreign import ccall "HROOTCoreTNamed.h TNamed_FindObject" c_tnamed_findobject 
  :: (Ptr RawTNamed) -> CString -> IO (Ptr RawTObject)

foreign import ccall "HROOTCoreTNamed.h TNamed_GetName" c_tnamed_getname 
  :: (Ptr RawTNamed) -> IO CString

foreign import ccall "HROOTCoreTNamed.h TNamed_IsA" c_tnamed_isa 
  :: (Ptr RawTNamed) -> IO (Ptr RawTClass)

foreign import ccall "HROOTCoreTNamed.h TNamed_Paint" c_tnamed_paint 
  :: (Ptr RawTNamed) -> CString -> IO ()

foreign import ccall "HROOTCoreTNamed.h TNamed_printObj" c_tnamed_printobj 
  :: (Ptr RawTNamed) -> CString -> IO ()

foreign import ccall "HROOTCoreTNamed.h TNamed_SaveAs" c_tnamed_saveas 
  :: (Ptr RawTNamed) -> CString -> CString -> IO ()

foreign import ccall "HROOTCoreTNamed.h TNamed_Write" c_tnamed_write 
  :: (Ptr RawTNamed) -> CString -> CInt -> CInt -> IO CInt

foreign import ccall "HROOTCoreTNamed.h TNamed_delete" c_tnamed_delete 
  :: (Ptr RawTNamed) -> IO ()

foreign import ccall "HROOTCoreTNamed.h TNamed_newTNamed" c_tnamed_newtnamed 
  :: CString -> CString -> IO (Ptr RawTNamed)

foreign import ccall "HROOTCoreTNamed.h TNamed_SetName" c_tnamed_setname 
  :: (Ptr RawTNamed) -> CString -> IO ()

foreign import ccall "HROOTCoreTNamed.h TNamed_SetNameTitle" c_tnamed_setnametitle 
  :: (Ptr RawTNamed) -> CString -> CString -> IO ()

foreign import ccall "HROOTCoreTNamed.h TNamed_SetTitle" c_tnamed_settitle 
  :: (Ptr RawTNamed) -> CString -> IO ()

