{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, 
             EmptyDataDecls, ExistentialQuantification, ScopedTypeVariables #-}

-- module HROOT.Class.Interface where

module HROOT.Core.TSeqCollection.Interface where


import Data.Word
import Foreign.C
import Foreign.Ptr
import Foreign.ForeignPtr
import FFICXX.Runtime.Cast

import HROOT.Core.TSeqCollection.RawType

import HROOT.Core.TCollection.Interface
---- ============ ----



class (ITCollection a) => ITSeqCollection a where

instance Existable TSeqCollection where
  data Exist TSeqCollection = forall a. (FPtr a, ITSeqCollection a) => ETSeqCollection a

upcastTSeqCollection :: (FPtr a, ITSeqCollection a) => a -> TSeqCollection
upcastTSeqCollection h = let fh = get_fptr h
                             fh2 :: ForeignPtr RawTSeqCollection = castForeignPtr fh
                         in cast_fptr_to_obj fh2

downcastTSeqCollection :: (FPtr a, ITSeqCollection a) => TSeqCollection -> a 
downcastTSeqCollection h = let fh = get_fptr h
                               fh2 = castForeignPtr fh
                           in cast_fptr_to_obj fh2
